#파이썬 크롤링 기초
# pip install lxml 을 윈도우 cmd 창에서 실행한다.
# pip install --upgrade pip
# pip list
# pip install requests
# pip install cssselect

from typing import get_args
import requests
from lxml.html import fromstring, tostring

def main():
    """
    네이버 지식인 스크랩핑 메인 함수
    """

    # 세션 사용
    session = requests.Session()

    # 스크랩핑 대상 URL (GET, POST)
    response = session.get("https://kin.naver.com/search/list.nhn?query=%ED%8C%8C%EC%9D%B4%EC%8D%AC")

    # 신문사 링크 리스트 획득
    urls = scrape_news_list_page(response)

    # 딕셔너리 확인
    # print(urls)

    # 결과 출력
    for name, url in urls.items():
        # url 출력
        print(name, url)

        # 파일 쓰기
        # 생략

def scrape_news_list_page(response):
    # url 리스트 선언
    urls = {}

    # 태그 정보 문자열 저장
    #print(response.content)
    root = fromstring(response.content)
    #print(root)

    for a in root.xpath('//ul[@class="basic1"]/li/dl/dt/a[@class="_nclicks:kin.txt _searchListTitleAnchor"]'):
        # a 구조 확인
        # print(a)

        # a 문자열 출력
        # print(tostring(a, pretty_print=True))

        name, url = extract_conents(a)
        # 딕셔너리 삽입
        urls[name] = url
        
    return urls

def extract_conents(doc):
    # 링크 주소
    link = doc.get("href")  
    name = doc.text_content()
    return name, link


# 스크랩핑 시작
if __name__ == "__main__":
    main()

